import React from "react";
import classNames from "classnames";
let ListItem = /** @class */ (() => {
    class ListItem extends React.PureComponent {
        constructor() {
            super(...arguments);
            this.saveNode = (dom) => {
                this.node = dom;
            };
        }
        render() {
            const { prefixCls, selected, children, active, disabled, getItemProps, onMouseEnter, onMouseLeave, data, value, onClick, } = this.props;
            const customProps = getItemProps(data);
            const classes = classNames({
                [`${prefixCls}`]: true,
                [`${prefixCls}-active`]: active,
                [`${prefixCls}-selected`]: selected,
                [`${prefixCls}-disabled`]: disabled,
                [customProps.className]: customProps.className,
            });
            return (React.createElement("div", Object.assign({ ref: this.saveNode }, customProps, { className: classes, onClick: (e) => {
                    onClick(value, e);
                    customProps.onClick?.(e);
                }, onMouseEnter: (e) => {
                    onMouseEnter(value, e);
                    customProps.onMouseEnter?.(e);
                }, onMouseLeave: (e) => {
                    onMouseLeave(value, e);
                    customProps.onMouseLeave?.(e);
                } }), children));
        }
    }
    ListItem.defaultProps = {
        data: {},
    };
    return ListItem;
})();
export { ListItem };
export default ListItem;
